(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof (root._bokeh_onload_callbacks) === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) { callback() });
        }
        finally {
          delete root._bokeh_onload_callbacks
        }
        console.info("Bokeh: all callbacks have finished");
      }
    
      function load_libs(js_urls, callback) {
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.log("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.log("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = js_urls.length;
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var s = document.createElement('script');
          s.src = url;
          s.async = false;
          s.onreadystatechange = s.onload = function() {
            root._bokeh_is_loading--;
            if (root._bokeh_is_loading === 0) {
              console.log("Bokeh: all BokehJS libraries loaded");
              run_callbacks()
            }
          };
          s.onerror = function() {
            console.warn("failed to load library " + url);
          };
          console.log("Bokeh: injecting script tag for BokehJS library: ", url);
          document.getElementsByTagName("head")[0].appendChild(s);
        }
      };var element = document.getElementById("bc02cb74-69b4-4ee2-ac67-fddc8ff7bdfb");
      if (element == null) {
        console.log("Bokeh: ERROR: autoload.js configured with elementid 'bc02cb74-69b4-4ee2-ac67-fddc8ff7bdfb' but no matching script tag was found. ")
        return false;
      }
    
      var js_urls = ["https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-gl-1.0.4.min.js"];
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"c458fc65-1d18-4d2a-9eb1-0c094046b274":{"roots":{"references":[{"attributes":{"callback":null,"tooltips":"@genus: @value"},"id":"1022","type":"HoverTool"},{"attributes":{"callback":null},"id":"1004","type":"DataRange1d"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"1022","type":"HoverTool"}]},"id":"1023","type":"Toolbar"},{"attributes":{"below":[{"id":"1012","type":"LinearAxis"}],"left":[{"id":"1017","type":"LinearAxis"}],"plot_height":350,"renderers":[{"id":"1012","type":"LinearAxis"},{"id":"1016","type":"Grid"},{"id":"1017","type":"LinearAxis"},{"id":"1021","type":"Grid"},{"id":"1038","type":"Legend"},{"id":"1031","type":"GlyphRenderer"}],"title":{"id":"1001","type":"Title"},"toolbar":{"id":"1023","type":"Toolbar"},"toolbar_location":null,"x_range":{"id":"1004","type":"DataRange1d"},"x_scale":{"id":"1008","type":"LinearScale"},"y_range":{"id":"1006","type":"DataRange1d"},"y_scale":{"id":"1010","type":"LinearScale"}},"id":"1002","subtype":"Figure","type":"Plot"},{"attributes":{"field":"angle"},"id":"1026","type":"CumSum"},{"attributes":{},"id":"1010","type":"LinearScale"},{"attributes":{"items":[{"id":"1039","type":"LegendItem"}],"plot":{"id":"1002","subtype":"Figure","type":"Plot"}},"id":"1038","type":"Legend"},{"attributes":{"callback":null,"data":{"angle":{"__ndarray__":"PomZWaK98T9TDCIig6fXP1MMIiKDp+c/UwwiIoOn1z9TDCIig6fXP1MMIiKDp9c/UwwiIoOn1z9TDCIig6fXP1MMIiKDp9c/UwwiIoOn1z9TDCIig6fXP1MMIiKDp9c/UwwiIoOn1z9TDCIig6fXPw==","dtype":"float64","shape":[14]},"genus":["Condica","Pericyma","Hyposidra","Hyblaea","Spirama","Clepsis","Ozarba","Speiredonia","Ercheia","Homona","Hipoepa","Chrysocraspeda","Nodaria","Eupithecia"],"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13],"value":[3,1,2,1,1,1,1,1,1,1,1,1,1,1]},"selected":{"id":"1045","type":"Selection"},"selection_policy":{"id":"1046","type":"UnionRenderers"}},"id":"1027","type":"ColumnDataSource"},{"attributes":{"formatter":{"id":"1037","type":"BasicTickFormatter"},"plot":{"id":"1002","subtype":"Figure","type":"Plot"},"ticker":{"id":"1013","type":"BasicTicker"}},"id":"1012","type":"LinearAxis"},{"attributes":{"callback":null},"id":"1006","type":"DataRange1d"},{"attributes":{"plot":{"id":"1002","subtype":"Figure","type":"Plot"},"ticker":{"id":"1013","type":"BasicTicker"}},"id":"1016","type":"Grid"},{"attributes":{"field":"angle","include_zero":true},"id":"1025","type":"CumSum"},{"attributes":{},"id":"1008","type":"LinearScale"},{"attributes":{},"id":"1013","type":"BasicTicker"},{"attributes":{"end_angle":{"expr":{"id":"1026","type":"CumSum"},"units":"rad"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"units":"data","value":0.4},"start_angle":{"expr":{"id":"1025","type":"CumSum"},"units":"rad"},"x":{"value":0},"y":{"value":1}},"id":"1030","type":"Wedge"},{"attributes":{"plot":null,"text":"Pie Chart"},"id":"1001","type":"Title"},{"attributes":{},"id":"1037","type":"BasicTickFormatter"},{"attributes":{"formatter":{"id":"1035","type":"BasicTickFormatter"},"plot":{"id":"1002","subtype":"Figure","type":"Plot"},"ticker":{"id":"1018","type":"BasicTicker"}},"id":"1017","type":"LinearAxis"},{"attributes":{},"id":"1045","type":"Selection"},{"attributes":{},"id":"1018","type":"BasicTicker"},{"attributes":{"end_angle":{"expr":{"id":"1026","type":"CumSum"},"units":"rad"},"fill_color":{"value":"#1f77b4"},"line_color":{"value":"white"},"radius":{"units":"data","value":0.4},"start_angle":{"expr":{"id":"1025","type":"CumSum"},"units":"rad"},"x":{"value":0},"y":{"value":1}},"id":"1029","type":"Wedge"},{"attributes":{},"id":"1046","type":"UnionRenderers"},{"attributes":{"data_source":{"id":"1027","type":"ColumnDataSource"},"glyph":{"id":"1029","type":"Wedge"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"1030","type":"Wedge"},"selection_glyph":null,"view":{"id":"1032","type":"CDSView"}},"id":"1031","type":"GlyphRenderer"},{"attributes":{"dimension":1,"plot":{"id":"1002","subtype":"Figure","type":"Plot"},"ticker":{"id":"1018","type":"BasicTicker"}},"id":"1021","type":"Grid"},{"attributes":{"label":{"field":"genus"},"renderers":[{"id":"1031","type":"GlyphRenderer"}]},"id":"1039","type":"LegendItem"},{"attributes":{"source":{"id":"1027","type":"ColumnDataSource"}},"id":"1032","type":"CDSView"},{"attributes":{},"id":"1035","type":"BasicTickFormatter"}],"root_ids":["1002"]},"title":"Bokeh Application","version":"1.0.4"}}';
                  var render_items = [{"docid":"c458fc65-1d18-4d2a-9eb1-0c094046b274","roots":{"1002":"bc02cb74-69b4-4ee2-ac67-fddc8ff7bdfb"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        embed_document(root);
                        clearInterval(timer);
                      }
                      attempts++;
                      if (attempts > 100) {
                        console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        clearInterval(timer);
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css");
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css");
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css");
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.log("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(js_urls, function() {
          console.log("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();