(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof (root._bokeh_onload_callbacks) === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) { callback() });
        }
        finally {
          delete root._bokeh_onload_callbacks
        }
        console.info("Bokeh: all callbacks have finished");
      }
    
      function load_libs(js_urls, callback) {
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.log("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.log("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = js_urls.length;
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var s = document.createElement('script');
          s.src = url;
          s.async = false;
          s.onreadystatechange = s.onload = function() {
            root._bokeh_is_loading--;
            if (root._bokeh_is_loading === 0) {
              console.log("Bokeh: all BokehJS libraries loaded");
              run_callbacks()
            }
          };
          s.onerror = function() {
            console.warn("failed to load library " + url);
          };
          console.log("Bokeh: injecting script tag for BokehJS library: ", url);
          document.getElementsByTagName("head")[0].appendChild(s);
        }
      };var element = document.getElementById("d23bf73b-991c-4b98-9aa7-ea97af50c014");
      if (element == null) {
        console.log("Bokeh: ERROR: autoload.js configured with elementid 'd23bf73b-991c-4b98-9aa7-ea97af50c014' but no matching script tag was found. ")
        return false;
      }
    
      var js_urls = ["https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-gl-1.0.4.min.js"];
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"4b6b0ae2-1cfd-432f-9019-59f9123c51a0":{"roots":{"references":[{"attributes":{},"id":"1268","type":"UnionRenderers"},{"attributes":{},"id":"1235","type":"BasicTicker"},{"attributes":{"data_source":{"id":"1249","type":"ColumnDataSource"},"glyph":{"id":"1251","type":"Wedge"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"1252","type":"Wedge"},"selection_glyph":null,"view":{"id":"1254","type":"CDSView"}},"id":"1253","type":"GlyphRenderer"},{"attributes":{"source":{"id":"1249","type":"ColumnDataSource"}},"id":"1254","type":"CDSView"},{"attributes":{},"id":"1257","type":"BasicTickFormatter"},{"attributes":{"callback":null},"id":"1228","type":"DataRange1d"},{"attributes":{"end_angle":{"expr":{"id":"1248","type":"CumSum"},"units":"rad"},"fill_color":{"value":"#1f77b4"},"line_color":{"value":"white"},"radius":{"units":"data","value":0.4},"start_angle":{"expr":{"id":"1247","type":"CumSum"},"units":"rad"},"x":{"value":0},"y":{"value":1}},"id":"1251","type":"Wedge"},{"attributes":{"below":[{"id":"1234","type":"LinearAxis"}],"left":[{"id":"1239","type":"LinearAxis"}],"plot_height":350,"renderers":[{"id":"1234","type":"LinearAxis"},{"id":"1238","type":"Grid"},{"id":"1239","type":"LinearAxis"},{"id":"1243","type":"Grid"},{"id":"1260","type":"Legend"},{"id":"1253","type":"GlyphRenderer"}],"title":{"id":"1223","type":"Title"},"toolbar":{"id":"1245","type":"Toolbar"},"toolbar_location":null,"x_range":{"id":"1226","type":"DataRange1d"},"x_scale":{"id":"1230","type":"LinearScale"},"y_range":{"id":"1228","type":"DataRange1d"},"y_scale":{"id":"1232","type":"LinearScale"}},"id":"1224","subtype":"Figure","type":"Plot"},{"attributes":{},"id":"1259","type":"BasicTickFormatter"},{"attributes":{},"id":"1230","type":"LinearScale"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"1244","type":"HoverTool"}]},"id":"1245","type":"Toolbar"},{"attributes":{"formatter":{"id":"1257","type":"BasicTickFormatter"},"plot":{"id":"1224","subtype":"Figure","type":"Plot"},"ticker":{"id":"1240","type":"BasicTicker"}},"id":"1239","type":"LinearAxis"},{"attributes":{"items":[{"id":"1261","type":"LegendItem"}],"plot":{"id":"1224","subtype":"Figure","type":"Plot"}},"id":"1260","type":"Legend"},{"attributes":{"callback":null,"data":{"angle":{"__ndarray__":"GC1EVPshyT8YLURU+yHZPxgtRFT7Ick/GC1EVPshyT8YLURU+yHJPxgtRFT7Ick/GC1EVPshyT8YLURU+yHpPxgtRFT7Idk/GC1EVPshyT8YLURU+yHJPxgtRFT7Idk/GC1EVPshyT8YLURU+yHJPxgtRFT7Ick/GC1EVPshyT8YLURU+yHJPxgtRFT7Ick/GC1EVPshyT8YLURU+yHJPxgtRFT7Ick/GC1EVPshyT8YLURU+yHJPxgtRFT7Ick/GC1EVPshyT8YLURU+yHJPw==","dtype":"float64","shape":[26]},"index":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25],"species":["Ataboruza divisa","Enispa elataria","Brunia antica","Hydrillodes lentalis","Cnaphalocrocis poeyalis","Cirrhochrista brizoalis","Herpetogramma licarsisalis","Arsacia rectalis","Pyrausta panopealis","Chiasmia nora","Maruca vitrata","Spodoptera litura","Daphnis nerii","Psilogramma increta","Polytela gloriosae","Parasa lepida","Derambila saponaria","Stathmopoda auriferella","Sameodes cancellalis","Agathia carissima","Banisia myrsusalis","Eublemma baccalix","Chiasmia fidoniata","Nosophora euryterminalis","Traminda mundissima","Spoladea recurvalis"],"value":[1,2,1,1,1,1,1,4,2,1,1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1]},"selected":{"id":"1267","type":"Selection"},"selection_policy":{"id":"1268","type":"UnionRenderers"}},"id":"1249","type":"ColumnDataSource"},{"attributes":{"callback":null},"id":"1226","type":"DataRange1d"},{"attributes":{"field":"angle","include_zero":true},"id":"1247","type":"CumSum"},{"attributes":{"label":{"field":"species"},"renderers":[{"id":"1253","type":"GlyphRenderer"}]},"id":"1261","type":"LegendItem"},{"attributes":{"dimension":1,"plot":{"id":"1224","subtype":"Figure","type":"Plot"},"ticker":{"id":"1240","type":"BasicTicker"}},"id":"1243","type":"Grid"},{"attributes":{"formatter":{"id":"1259","type":"BasicTickFormatter"},"plot":{"id":"1224","subtype":"Figure","type":"Plot"},"ticker":{"id":"1235","type":"BasicTicker"}},"id":"1234","type":"LinearAxis"},{"attributes":{},"id":"1240","type":"BasicTicker"},{"attributes":{"plot":{"id":"1224","subtype":"Figure","type":"Plot"},"ticker":{"id":"1235","type":"BasicTicker"}},"id":"1238","type":"Grid"},{"attributes":{"end_angle":{"expr":{"id":"1248","type":"CumSum"},"units":"rad"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"units":"data","value":0.4},"start_angle":{"expr":{"id":"1247","type":"CumSum"},"units":"rad"},"x":{"value":0},"y":{"value":1}},"id":"1252","type":"Wedge"},{"attributes":{"field":"angle"},"id":"1248","type":"CumSum"},{"attributes":{},"id":"1232","type":"LinearScale"},{"attributes":{"callback":null,"tooltips":"@species: @value"},"id":"1244","type":"HoverTool"},{"attributes":{},"id":"1267","type":"Selection"},{"attributes":{"plot":null,"text":"Pie Chart"},"id":"1223","type":"Title"}],"root_ids":["1224"]},"title":"Bokeh Application","version":"1.0.4"}}';
                  var render_items = [{"docid":"4b6b0ae2-1cfd-432f-9019-59f9123c51a0","roots":{"1224":"d23bf73b-991c-4b98-9aa7-ea97af50c014"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        embed_document(root);
                        clearInterval(timer);
                      }
                      attempts++;
                      if (attempts > 100) {
                        console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        clearInterval(timer);
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css");
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css");
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css");
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.log("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(js_urls, function() {
          console.log("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();