(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof (root._bokeh_onload_callbacks) === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) { callback() });
        }
        finally {
          delete root._bokeh_onload_callbacks
        }
        console.info("Bokeh: all callbacks have finished");
      }
    
      function load_libs(js_urls, callback) {
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.log("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.log("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = js_urls.length;
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var s = document.createElement('script');
          s.src = url;
          s.async = false;
          s.onreadystatechange = s.onload = function() {
            root._bokeh_is_loading--;
            if (root._bokeh_is_loading === 0) {
              console.log("Bokeh: all BokehJS libraries loaded");
              run_callbacks()
            }
          };
          s.onerror = function() {
            console.warn("failed to load library " + url);
          };
          console.log("Bokeh: injecting script tag for BokehJS library: ", url);
          document.getElementsByTagName("head")[0].appendChild(s);
        }
      };var element = document.getElementById("3e2d0a43-951b-4bf4-a01d-a91769838e25");
      if (element == null) {
        console.log("Bokeh: ERROR: autoload.js configured with elementid '3e2d0a43-951b-4bf4-a01d-a91769838e25' but no matching script tag was found. ")
        return false;
      }
    
      var js_urls = ["https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-gl-1.0.4.min.js"];
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"a90ebf45-1813-495d-81d7-5a34f0a1da6d":{"roots":{"references":[{"attributes":{"end_angle":{"expr":{"id":"1100","type":"CumSum"},"units":"rad"},"fill_color":{"value":"#1f77b4"},"line_color":{"value":"white"},"radius":{"units":"data","value":0.4},"start_angle":{"expr":{"id":"1099","type":"CumSum"},"units":"rad"},"x":{"value":0},"y":{"value":1}},"id":"1103","type":"Wedge"},{"attributes":{},"id":"1092","type":"BasicTicker"},{"attributes":{},"id":"1119","type":"Selection"},{"attributes":{"data_source":{"id":"1101","type":"ColumnDataSource"},"glyph":{"id":"1103","type":"Wedge"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"1104","type":"Wedge"},"selection_glyph":null,"view":{"id":"1106","type":"CDSView"}},"id":"1105","type":"GlyphRenderer"},{"attributes":{"dimension":1,"plot":{"id":"1076","subtype":"Figure","type":"Plot"},"ticker":{"id":"1092","type":"BasicTicker"}},"id":"1095","type":"Grid"},{"attributes":{"field":"angle"},"id":"1100","type":"CumSum"},{"attributes":{"source":{"id":"1101","type":"ColumnDataSource"}},"id":"1106","type":"CDSView"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"1096","type":"HoverTool"}]},"id":"1097","type":"Toolbar"},{"attributes":{"label":{"field":"tribe"},"renderers":[{"id":"1105","type":"GlyphRenderer"}]},"id":"1113","type":"LegendItem"},{"attributes":{},"id":"1109","type":"BasicTickFormatter"},{"attributes":{"callback":null},"id":"1080","type":"DataRange1d"},{"attributes":{},"id":"1087","type":"BasicTicker"},{"attributes":{},"id":"1111","type":"BasicTickFormatter"},{"attributes":{},"id":"1082","type":"LinearScale"},{"attributes":{},"id":"1084","type":"LinearScale"},{"attributes":{"below":[{"id":"1086","type":"LinearAxis"}],"left":[{"id":"1091","type":"LinearAxis"}],"plot_height":350,"renderers":[{"id":"1086","type":"LinearAxis"},{"id":"1090","type":"Grid"},{"id":"1091","type":"LinearAxis"},{"id":"1095","type":"Grid"},{"id":"1112","type":"Legend"},{"id":"1105","type":"GlyphRenderer"}],"title":{"id":"1075","type":"Title"},"toolbar":{"id":"1097","type":"Toolbar"},"toolbar_location":null,"x_range":{"id":"1078","type":"DataRange1d"},"x_scale":{"id":"1082","type":"LinearScale"},"y_range":{"id":"1080","type":"DataRange1d"},"y_scale":{"id":"1084","type":"LinearScale"}},"id":"1076","subtype":"Figure","type":"Plot"},{"attributes":{"items":[{"id":"1113","type":"LegendItem"}],"plot":{"id":"1076","subtype":"Figure","type":"Plot"}},"id":"1112","type":"Legend"},{"attributes":{"callback":null},"id":"1078","type":"DataRange1d"},{"attributes":{"callback":null,"data":{"angle":{"__ndarray__":"QKG7Ox+57D9Aobs7H7nsP0Chuzsfuew/QKG7Ox+5/D9Aobs7H7nsP0Chuzsfuew/","dtype":"float64","shape":[6]},"index":[0,1,2,3,4,5],"tribe":["Eupitheciini","Orgyiini","Grapholitini","Archipini","Eucosmini","Boarmiini"],"value":[1,1,1,2,1,1]},"selected":{"id":"1119","type":"Selection"},"selection_policy":{"id":"1120","type":"UnionRenderers"}},"id":"1101","type":"ColumnDataSource"},{"attributes":{"plot":null,"text":"Pie Chart"},"id":"1075","type":"Title"},{"attributes":{"field":"angle","include_zero":true},"id":"1099","type":"CumSum"},{"attributes":{"callback":null,"tooltips":"@tribe: @value"},"id":"1096","type":"HoverTool"},{"attributes":{"end_angle":{"expr":{"id":"1100","type":"CumSum"},"units":"rad"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"units":"data","value":0.4},"start_angle":{"expr":{"id":"1099","type":"CumSum"},"units":"rad"},"x":{"value":0},"y":{"value":1}},"id":"1104","type":"Wedge"},{"attributes":{},"id":"1120","type":"UnionRenderers"},{"attributes":{"plot":{"id":"1076","subtype":"Figure","type":"Plot"},"ticker":{"id":"1087","type":"BasicTicker"}},"id":"1090","type":"Grid"},{"attributes":{"formatter":{"id":"1109","type":"BasicTickFormatter"},"plot":{"id":"1076","subtype":"Figure","type":"Plot"},"ticker":{"id":"1092","type":"BasicTicker"}},"id":"1091","type":"LinearAxis"},{"attributes":{"formatter":{"id":"1111","type":"BasicTickFormatter"},"plot":{"id":"1076","subtype":"Figure","type":"Plot"},"ticker":{"id":"1087","type":"BasicTicker"}},"id":"1086","type":"LinearAxis"}],"root_ids":["1076"]},"title":"Bokeh Application","version":"1.0.4"}}';
                  var render_items = [{"docid":"a90ebf45-1813-495d-81d7-5a34f0a1da6d","roots":{"1076":"3e2d0a43-951b-4bf4-a01d-a91769838e25"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        embed_document(root);
                        clearInterval(timer);
                      }
                      attempts++;
                      if (attempts > 100) {
                        console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        clearInterval(timer);
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css");
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css");
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css");
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.log("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(js_urls, function() {
          console.log("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();