(function() {
  var fn = function() {
    
    (function(root) {
      function now() {
        return new Date();
      }
    
      var force = false;
    
      if (typeof (root._bokeh_onload_callbacks) === "undefined" || force === true) {
        root._bokeh_onload_callbacks = [];
        root._bokeh_is_loading = undefined;
      }
    
      
      
    
      
      
    
      function run_callbacks() {
        try {
          root._bokeh_onload_callbacks.forEach(function(callback) { callback() });
        }
        finally {
          delete root._bokeh_onload_callbacks
        }
        console.info("Bokeh: all callbacks have finished");
      }
    
      function load_libs(js_urls, callback) {
        root._bokeh_onload_callbacks.push(callback);
        if (root._bokeh_is_loading > 0) {
          console.log("Bokeh: BokehJS is being loaded, scheduling callback at", now());
          return null;
        }
        if (js_urls == null || js_urls.length === 0) {
          run_callbacks();
          return null;
        }
        console.log("Bokeh: BokehJS not loaded, scheduling load and callback at", now());
        root._bokeh_is_loading = js_urls.length;
        for (var i = 0; i < js_urls.length; i++) {
          var url = js_urls[i];
          var s = document.createElement('script');
          s.src = url;
          s.async = false;
          s.onreadystatechange = s.onload = function() {
            root._bokeh_is_loading--;
            if (root._bokeh_is_loading === 0) {
              console.log("Bokeh: all BokehJS libraries loaded");
              run_callbacks()
            }
          };
          s.onerror = function() {
            console.warn("failed to load library " + url);
          };
          console.log("Bokeh: injecting script tag for BokehJS library: ", url);
          document.getElementsByTagName("head")[0].appendChild(s);
        }
      };var element = document.getElementById("dfdc7ff1-e8f7-455e-938e-b133dcffb623");
      if (element == null) {
        console.log("Bokeh: ERROR: autoload.js configured with elementid 'dfdc7ff1-e8f7-455e-938e-b133dcffb623' but no matching script tag was found. ")
        return false;
      }
    
      var js_urls = ["https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.js", "https://cdn.pydata.org/bokeh/release/bokeh-gl-1.0.4.min.js"];
    
      var inline_js = [
        function(Bokeh) {
          Bokeh.set_log_level("info");
        },
        
        function(Bokeh) {
          
        },
        
        function(Bokeh) {
          (function() {
            var fn = function() {
              Bokeh.safely(function() {
                (function(root) {
                  function embed_document(root) {
                    
                  var docs_json = '{"3f4b5cf9-248a-47eb-9f7b-fd51f9ce2c56":{"roots":{"references":[{"attributes":{"data_source":{"id":"1175","type":"ColumnDataSource"},"glyph":{"id":"1177","type":"Wedge"},"hover_glyph":null,"muted_glyph":null,"nonselection_glyph":{"id":"1178","type":"Wedge"},"selection_glyph":null,"view":{"id":"1180","type":"CDSView"}},"id":"1179","type":"GlyphRenderer"},{"attributes":{"label":{"field":"family"},"renderers":[{"id":"1179","type":"GlyphRenderer"}]},"id":"1187","type":"LegendItem"},{"attributes":{"end_angle":{"expr":{"id":"1174","type":"CumSum"},"units":"rad"},"fill_alpha":{"value":0.1},"fill_color":{"value":"#1f77b4"},"line_alpha":{"value":0.1},"line_color":{"value":"#1f77b4"},"radius":{"units":"data","value":0.4},"start_angle":{"expr":{"id":"1173","type":"CumSum"},"units":"rad"},"x":{"value":0},"y":{"value":1}},"id":"1178","type":"Wedge"},{"attributes":{"items":[{"id":"1187","type":"LegendItem"}],"plot":{"id":"1150","subtype":"Figure","type":"Plot"}},"id":"1186","type":"Legend"},{"attributes":{"callback":null,"data":{"angle":{"__ndarray__":"4PCcdi8bBEDg8Jx2Lxv0P+DwnHYvG/Q/4PCcdi8b9D8=","dtype":"float64","shape":[4]},"family":["Noctuidae","Geometridae","Erebidae","Crambidae"],"index":[0,1,2,3],"value":[2,1,1,1]},"selected":{"id":"1193","type":"Selection"},"selection_policy":{"id":"1194","type":"UnionRenderers"}},"id":"1175","type":"ColumnDataSource"},{"attributes":{"field":"angle","include_zero":true},"id":"1173","type":"CumSum"},{"attributes":{},"id":"1156","type":"LinearScale"},{"attributes":{},"id":"1185","type":"BasicTickFormatter"},{"attributes":{"field":"angle"},"id":"1174","type":"CumSum"},{"attributes":{"callback":null},"id":"1154","type":"DataRange1d"},{"attributes":{"callback":null},"id":"1152","type":"DataRange1d"},{"attributes":{"plot":null,"text":"Pie Chart"},"id":"1149","type":"Title"},{"attributes":{"callback":null,"tooltips":"@family: @value"},"id":"1170","type":"HoverTool"},{"attributes":{},"id":"1183","type":"BasicTickFormatter"},{"attributes":{"end_angle":{"expr":{"id":"1174","type":"CumSum"},"units":"rad"},"fill_color":{"value":"#1f77b4"},"line_color":{"value":"white"},"radius":{"units":"data","value":0.4},"start_angle":{"expr":{"id":"1173","type":"CumSum"},"units":"rad"},"x":{"value":0},"y":{"value":1}},"id":"1177","type":"Wedge"},{"attributes":{"below":[{"id":"1160","type":"LinearAxis"}],"left":[{"id":"1165","type":"LinearAxis"}],"plot_height":350,"renderers":[{"id":"1160","type":"LinearAxis"},{"id":"1164","type":"Grid"},{"id":"1165","type":"LinearAxis"},{"id":"1169","type":"Grid"},{"id":"1186","type":"Legend"},{"id":"1179","type":"GlyphRenderer"}],"title":{"id":"1149","type":"Title"},"toolbar":{"id":"1171","type":"Toolbar"},"toolbar_location":null,"x_range":{"id":"1152","type":"DataRange1d"},"x_scale":{"id":"1156","type":"LinearScale"},"y_range":{"id":"1154","type":"DataRange1d"},"y_scale":{"id":"1158","type":"LinearScale"}},"id":"1150","subtype":"Figure","type":"Plot"},{"attributes":{"formatter":{"id":"1183","type":"BasicTickFormatter"},"plot":{"id":"1150","subtype":"Figure","type":"Plot"},"ticker":{"id":"1166","type":"BasicTicker"}},"id":"1165","type":"LinearAxis"},{"attributes":{},"id":"1193","type":"Selection"},{"attributes":{"source":{"id":"1175","type":"ColumnDataSource"}},"id":"1180","type":"CDSView"},{"attributes":{"active_drag":"auto","active_inspect":"auto","active_multi":null,"active_scroll":"auto","active_tap":"auto","tools":[{"id":"1170","type":"HoverTool"}]},"id":"1171","type":"Toolbar"},{"attributes":{"dimension":1,"plot":{"id":"1150","subtype":"Figure","type":"Plot"},"ticker":{"id":"1166","type":"BasicTicker"}},"id":"1169","type":"Grid"},{"attributes":{},"id":"1161","type":"BasicTicker"},{"attributes":{"formatter":{"id":"1185","type":"BasicTickFormatter"},"plot":{"id":"1150","subtype":"Figure","type":"Plot"},"ticker":{"id":"1161","type":"BasicTicker"}},"id":"1160","type":"LinearAxis"},{"attributes":{},"id":"1166","type":"BasicTicker"},{"attributes":{},"id":"1158","type":"LinearScale"},{"attributes":{},"id":"1194","type":"UnionRenderers"},{"attributes":{"plot":{"id":"1150","subtype":"Figure","type":"Plot"},"ticker":{"id":"1161","type":"BasicTicker"}},"id":"1164","type":"Grid"}],"root_ids":["1150"]},"title":"Bokeh Application","version":"1.0.4"}}';
                  var render_items = [{"docid":"3f4b5cf9-248a-47eb-9f7b-fd51f9ce2c56","roots":{"1150":"dfdc7ff1-e8f7-455e-938e-b133dcffb623"}}];
                  root.Bokeh.embed.embed_items(docs_json, render_items);
                
                  }
                  if (root.Bokeh !== undefined) {
                    embed_document(root);
                  } else {
                    var attempts = 0;
                    var timer = setInterval(function(root) {
                      if (root.Bokeh !== undefined) {
                        embed_document(root);
                        clearInterval(timer);
                      }
                      attempts++;
                      if (attempts > 100) {
                        console.log("Bokeh: ERROR: Unable to run BokehJS code because BokehJS library is missing");
                        clearInterval(timer);
                      }
                    }, 10, root)
                  }
                })(window);
              });
            };
            if (document.readyState != "loading") fn();
            else document.addEventListener("DOMContentLoaded", fn);
          })();
        },
        function(Bokeh) {
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-1.0.4.min.css");
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-widgets-1.0.4.min.css");
          console.log("Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css");
          Bokeh.embed.inject_css("https://cdn.pydata.org/bokeh/release/bokeh-tables-1.0.4.min.css");
        }
      ];
    
      function run_inline_js() {
        
        for (var i = 0; i < inline_js.length; i++) {
          inline_js[i].call(root, root.Bokeh);
        }
        
      }
    
      if (root._bokeh_is_loading === 0) {
        console.log("Bokeh: BokehJS loaded, going straight to plotting");
        run_inline_js();
      } else {
        load_libs(js_urls, function() {
          console.log("Bokeh: BokehJS plotting callback run at", now());
          run_inline_js();
        });
      }
    }(window));
  };
  if (document.readyState != "loading") fn();
  else document.addEventListener("DOMContentLoaded", fn);
})();